Bug 1011238 - Scanner does not work on USB3 interface
Summary: Scanner does not work on USB3 interface
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: sane-backends   
(Show other bugs)
Version: 21
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Nils Philippsen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-09-23 20:56 UTC by Nathan Samson
Modified: 2015-12-02 16:06 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-02 02:58:11 UTC
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

Description Nathan Samson 2013-09-23 20:56:19 UTC
Description of problem:
USB Scanner can not scan if connected to a USB3 port.


Version-Release number of selected component (if applicable):
Not sure, I selected sane, but I am not  sure if it is not a kernel problem


How reproducible:
Always on USB3 port with my scanner (combo printer)


Steps to Reproduce:
1. Buy a DPC-7060D (or possibly another USB printer/scanner)
2. Install all brother drivers (so that scanimage -L detects it)
3. Try to scan (imagescan > test.scan)

Actual results:
> [nathan@omega ~]$ scanimage > test.scan
> scanimage: rounded value of br-x from 215.9 to 215.88
> scanimage: rounded value of br-y from 355.6 to 355.567
> scanimage: sane_start: Invalid argument
> [nathan@omega ~]$ 
No scanning actually happens


Expected results:
It scans.
(On another Fedora 19 with USB2 ports it works).

Additional info:

[nathan@omega ~]$ scanimage -L
device `brother4:bus4;dev2' is a Brother DCP-7060D USB scanner

dmesg
------
[12781.607808] usb 3-3: new high-speed USB device number 3 using xhci_hcd
[12781.620832] usb 3-3: New USB device found, idVendor=04f9, idProduct=0249
[12781.620839] usb 3-3: New USB device strings: Mfr=0, Product=0, SerialNumber=3
[12781.620843] usb 3-3: SerialNumber: E69751B3N247048
[12781.719366] usblp 3-3:1.0: usblp0: USB Bidirectional printer dev 3 if 0 alt 0 proto 2 vid 0x04F9 pid 0x0249
[12781.719438] usbcore: registered new interface driver usblp
[12782.859761] usblp0: removed
[12782.861778] usblp 3-3:1.0: usblp0: USB Bidirectional printer dev 3 if 0 alt 0 proto 2 vid 0x04F9 pid 0x0249
[12803.584229] lp: driver loaded but no devices found
[12864.839528] usb 3-3: usbfs: interface 0 claimed by usblp while 'scanimage' sets config #1
[12864.839535] usb 3-3: usbfs: process 5074 (scanimage) did not claim interface 1 before use
[12865.939631] usb 3-3: usbfs: interface 0 claimed by usblp while 'scanimage' sets config #1
[12865.939636] usb 3-3: usbfs: process 5074 (scanimage) did not claim interface 1 before use

Comment 1 Andreas Kupfer 2013-09-27 17:07:50 UTC
Same here:

[akupfer@beckett 2013]$ scanimage -L
device `brother3:bus4;dev4' is a Brother DCP-195C USB scanner

It doesn't work when attached to the USB3 port, but works when I switch it to the USB2 port.

Comment 2 kwadronaut-redhat.com 2014-09-30 11:44:38 UTC
Identical with a Brother DCP-110C USB scanner, works on USB2, not on 3.

[310720.730812] usb 1-1.1: usbfs: interface 0 claimed by usblp while 'scan-thread' sets config #1
[310720.730831] usb 1-1.1: usbfs: process 519 (scan-thread) did not claim interface 1 before use

Comment 3 Erwan LE PENNEC 2014-11-25 20:14:26 UTC
Same issue on Fedora 20 and Fedora 21 with a Samsung SCX-4500 Series with an all USB3 HP EliteBook.
Disabling ehci in the bios and thus using USB2 solves the issue.

Comment 4 Erwan LE PENNEC 2014-11-26 09:08:54 UTC
I meant xhci and not ehci...

Comment 5 Fedora End Of Life 2015-01-09 19:57:31 UTC
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 6 Nathan Samson 2015-01-09 20:11:36 UTC
Still a problem in fedora 21

jan 09 21:06:26 omega kernel: usb 3-1.2: usbfs: interface 0 claimed by usblp while 'scan-thread' sets config #1
jan 09 21:06:26 omega kernel: usb 3-1.2: usbfs: process 4843 (scan-thread) did not claim interface 1 before use
jan 09 21:06:27 omega kernel: usb 3-1.2: usbfs: interface 0 claimed by usblp while 'scan-thread' sets config #1
jan 09 21:06:27 omega kernel: usb 3-1.2: usbfs: process 4843 (scan-thread) did not claim interface 1 before use

Comment 7 Mo Morsi 2015-08-21 13:11:38 UTC
Running into the same issue w/ the scanner part of the Brother MFC-240C. It was working on previous versions of Fedora, though can't say when it stopped.

After plugging in the scanner and turning it on, the initial run of scanimage yields:

$ scanimage > foo.tiff
scanimage: rounded value of br-x from 215.9 to 215.88
scanimage: rounded value of br-y from 355.6 to 355.567
scanimage: sane_start: Invalid argument

Perhaps of interest, I hear the actual scanner slightly adjust before this happens so perhaps a misconfiguration of parameters.

Subsequent runs yields different output:

$ scanimage > foo.tiff
scanimage: open of device brother2:bus4;dev2 failed: Invalid argument


The brscan2 driver has been installed from Brother's website

Other forums suggested removing the usblp and usb_storage modules as well as blacklisting them. Also adding the current user to the 'lp' group, changing the perms on the usb device file, and disabling selinux. None of these seem to resolve the problem.

Comment 8 Mo Morsi 2015-08-21 13:15:22 UTC
Running scanimage using strace results in:

[pid  6980] open("/dev/tty", O_RDWR|O_NONBLOCK) = 3
[pid  6980] close(3)                    = 0
[pid  6980] brk(0)                      = 0xe6e000
[pid  6980] brk(0xe8f000)               = 0xe8f000
[pid  6980] brk(0)                      = 0xe8f000
[pid  6980] open("/usr/lib/locale/locale-archive", O_RDONLY|O_CLOEXEC) = 3
[pid  6980] fstat(3, {st_mode=S_IFREG|0644, st_size=106374736, ...}) = 0
[pid  6980] mmap(NULL, 106374736, PROT_READ, MAP_PRIVATE, 3, 0) = 0x7fd5452da000
[pid  6980] close(3)                    = 0
[pid  6980] brk(0)                      = 0xe8f000
[pid  6980] getuid()                    = 1000
[pid  6980] getgid()                    = 1000
[pid  6980] geteuid()                   = 1000
[pid  6980] getegid()                   = 1000
[pid  6980] rt_sigprocmask(SIG_BLOCK, NULL, [], 8) = 0
[pid  6980] open("/proc/meminfo", O_RDONLY|O_CLOEXEC) = 3
[pid  6980] fstat(3, {st_mode=S_IFREG|0444, st_size=0, ...}) = 0
[pid  6980] mmap(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x7fd54c257000
[pid  6980] read(3, "MemTotal:       16115164 kB\nMemF"..., 1024) = 1024
[pid  6980] close(3)                    = 0
[pid  6980] munmap(0x7fd54c257000, 4096) = 0
[pid  6980] rt_sigaction(SIGCHLD, {SIG_DFL, [], SA_RESTORER|SA_RESTART, 0x7fd54b881960}, {SIG_DFL, [], 0}, 8) = 0
[pid  6980] rt_sigaction(SIGCHLD, {SIG_DFL, [], SA_RESTORER|SA_RESTART, 0x7fd54b881960}, {SIG_DFL, [], SA_RESTORER|SA_RESTART, 0x7fd54b881960}, 8) = 0
[pid  6980] rt_sigaction(SIGINT, {SIG_DFL, [], SA_RESTORER, 0x7fd54b881960}, {SIG_DFL, [], 0}, 8) = 0
[pid  6980] rt_sigaction(SIGINT, {SIG_DFL, [], SA_RESTORER, 0x7fd54b881960}, {SIG_DFL, [], SA_RESTORER, 0x7fd54b881960}, 8) = 0
[pid  6980] rt_sigaction(SIGQUIT, {SIG_DFL, [], SA_RESTORER, 0x7fd54b881960}, {SIG_DFL, [], 0}, 8) = 0
[pid  6980] rt_sigaction(SIGQUIT, {SIG_DFL, [], SA_RESTORER, 0x7fd54b881960}, {SIG_DFL, [], SA_RESTORER, 0x7fd54b881960}, 8) = 0
[pid  6980] rt_sigprocmask(SIG_BLOCK, NULL, [], 8) = 0
[pid  6980] rt_sigaction(SIGQUIT, {SIG_IGN, [], SA_RESTORER, 0x7fd54b881960}, {SIG_DFL, [], SA_RESTORER, 0x7fd54b881960}, 8) = 0
[pid  6980] uname({sysname="Linux", nodename="localhost.localdomain", ...}) = 0
[pid  6980] stat("/home/mmorsi", {st_mode=S_IFDIR|0711, st_size=4096, ...}) = 0
[pid  6980] stat(".", {st_mode=S_IFDIR|0711, st_size=4096, ...}) = 0
[pid  6980] getpid()                    = 6980
[pid  6980] open("/usr/lib64/gconv/gconv-modules.cache", O_RDONLY) = 3
[pid  6980] fstat(3, {st_mode=S_IFREG|0644, st_size=26254, ...}) = 0
[pid  6980] mmap(NULL, 26254, PROT_READ, MAP_SHARED, 3, 0) = 0x7fd54c251000
[pid  6980] close(3)                    = 0
[pid  6980] getppid()                   = 6977
[pid  6980] getpgrp()                   = 6975
[pid  6980] rt_sigaction(SIGCHLD, {0x445ca0, [], SA_RESTORER|SA_RESTART, 0x7fd54b881960}, {SIG_DFL, [], SA_RESTORER|SA_RESTART, 0x7fd54b881960}, 8) = 0
[pid  6980] getrlimit(RLIMIT_NPROC, {rlim_cur=4*1024, rlim_max=62863}) = 0
[pid  6980] rt_sigprocmask(SIG_BLOCK, NULL, [], 8) = 0
[pid  6980] open("/usr/bin/brscan-skey", O_RDONLY) = 3
[pid  6980] ioctl(3, TCGETS, 0x7ffdde8bf790) = -1 ENOTTY (Inappropriate ioctl for device)
[pid  6980] lseek(3, 0, SEEK_CUR)       = 0
[pid  6980] read(3, "#! /bin/sh\n\n\nif [ \"$1\" = \"-h\" ] "..., 80) = 80
[pid  6980] lseek(3, 0, SEEK_SET)       = 0
[pid  6980] getrlimit(RLIMIT_NOFILE, {rlim_cur=1024, rlim_max=4*1024}) = 0
[pid  6980] fcntl(255, F_GETFD)         = -1 EBADF (Bad file descriptor)
[pid  6980] dup2(3, 255)                = 255
[pid  6980] close(3)                    = 0
[pid  6980] fcntl(255, F_SETFD, FD_CLOEXEC) = 0
[pid  6980] fcntl(255, F_GETFL)         = 0x8000 (flags O_RDONLY|O_LARGEFILE)
[pid  6980] fstat(255, {st_mode=S_IFREG|0755, st_size=1160, ...}) = 0
[pid  6980] lseek(255, 0, SEEK_CUR)     = 0
[pid  6980] read(255, "#! /bin/sh\n\n\nif [ \"$1\" = \"-h\" ] "..., 1160) = 1160
[pid  6980] fstat(1, {st_mode=S_IFIFO|0600, st_size=0, ...}) = 0
[pid  6980] mmap(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x7fd54c250000
[pid  6980] write(1, "   Copyright 2007-2012 Brother I"..., 47) = 47
[pid  6977] <... read resumed> "   Copyright 2007-2012 Brother I"..., 4096) = 47
[pid  6980] rt_sigprocmask(SIG_BLOCK, [CHLD],  <unfinished ...>
[pid  6977] read(202,  <unfinished ...>
[pid  6980] <... rt_sigprocmask resumed> [], 8) = 0
[pid  6980] rt_sigprocmask(SIG_SETMASK, [], NULL, 8) = 0
[pid  6980] exit_group(0)               = ?
[pid  6977] <... read resumed> "", 4096) = 0
[pid  6980] +++ exited with 0 +++
[pid  6977] --- SIGCHLD {si_signo=SIGCHLD, si_code=CLD_EXITED, si_pid=6980, si_uid=1000, si_status=0, si_utime=0, si_stime=0} ---
[pid  6977] close(202)                  = 0
[pid  6977] wait4(6980, [{WIFEXITED(s) && WEXITSTATUS(s) == 0}], 0, NULL) = 6980
[pid  6977] munmap(0x7f46244bd000, 4096) = 0
[pid  6977] semget(IPC_PRIVATE, 1, IPC_CREAT|IPC_EXCL|0666) = 1998871
[pid  6977] semctl(1998871, 0, SETVAL, 0x1) = 0
[pid  6977] semop(1998871, {{0, -1, SEM_UNDO}}, 1) = 0
[pid  6977] ioctl(196, USBDEVFS_CLAIMINTERFACE, 0x7ffceec2ac7c) = 0
[pid  6977] timerfd_settime(10, TFD_TIMER_ABSTIME, {it_interval={0, 0}, it_value={6357, 787018000}}, NULL) = 0
[pid  6977] ioctl(196, USBDEVFS_SUBMITURB, 0x7f4625f5ca80) = 0
[pid  6977] poll([{fd=6, events=POLLIN}, {fd=8, events=POLLIN}, {fd=10, events=POLLIN}, {fd=196, events=POLLOUT}], 4, 60000) = 1 ([{fd=196, revents=POLLOUT}])
[pid  6977] ioctl(196, USBDEVFS_REAPURBNDELAY, 0x7ffceec2aaf0) = 0
[pid  6977] timerfd_settime(10, 0, {it_interval={0, 0}, it_value={0, 0}}, NULL) = 0
[pid  6977] ioctl(196, USBDEVFS_REAPURBNDELAY, 0x7ffceec2aaf0) = -1 EAGAIN (Resource temporarily unavailable)
[pid  6977] brk(0)                      = 0x7f4625f63000
[pid  6977] brk(0x7f4625f85000)         = 0x7f4625f85000
[pid  6977] nanosleep({0, 30000000}, NULL) = 0
[pid  6977] timerfd_settime(10, TFD_TIMER_ABSTIME, {it_interval={0, 0}, it_value={6357, 817959000}}, NULL) = 0
[pid  6977] ioctl(196, USBDEVFS_SUBMITURB, 0x7f4625f64780) = 0
[pid  6977] poll([{fd=6, events=POLLIN}, {fd=8, events=POLLIN}, {fd=10, events=POLLIN}, {fd=196, events=POLLOUT}], 4, 60000) = 1 ([{fd=196, revents=POLLOUT}])
[pid  6977] ioctl(196, USBDEVFS_REAPURBNDELAY, 0x7ffceec2aaf0) = 0
[pid  6977] timerfd_settime(10, 0, {it_interval={0, 0}, it_value={0, 0}}, NULL) = 0
[pid  6977] ioctl(196, USBDEVFS_REAPURBNDELAY, 0x7ffceec2aaf0) = -1 EAGAIN (Resource temporarily unavailable)
[pid  6977] nanosleep({0, 30000000}, NULL) = 0

Comment 9 Fedora End Of Life 2015-11-04 10:44:41 UTC
This message is a reminder that Fedora 21 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 21. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '21'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 21 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 10 Phil Wiggum 2015-11-09 14:44:42 UTC
Same problem on Fedora 23 but there is a workaround!

In my case I solved it by installing a PCI USB 2 card.
This card is routed to 'ohci-hcd' instead of 'xhci-hcd'

For anyone having same problem, this might help...
Brother MFC-7420
GigaByte G1.Sniper Z87 Rev 1.1

$ sudo dnf install sane-backends sane-frontends
$ sudo rpm -i brscan2-0.2.5-1.x86_64.rpm
$ sudo rpm -i brscan-skey-0.2.4-1.x86_64.rpm
$ grep -q 'brother2' /etc/sane.d/dll.conf || sudo echo 'brother2' >> /etc/sane.d/dll.conf

Test:
$ sane-find-scanner
found USB scanner (vendor=0x04f9, product=0x0180) at libusb:006:004
$ dmesg | grep usb 6 
usb 6-3: new full-speed USB device number 2 using ohci-pci
$ scanimage -L
device `brother2:bus4;dev1' is a Brother MFC-7420 USB scanner
$ brscan-skey -L
MFC-7420   : brother2:bus4;dev1  : USB     Not registered
xsane

The Z87 motherboard has 4 USB3/2 and 2 USB2 ports on the back panel. 
A USB2 gadget is always routed to usb1 (USB3 or USB2 ports)
A USB3 gadget is routed to usb2 (USB3)

$ dmesg
usb usb1: Manufacturer: Linux 4.2.5-300.fc23.x86_64 xhci-hcd
usb usb1: SerialNumber: 0000:00:14.0
hub 1-0:1.0: USB hub found
hub 1-0:1.0: 14 ports detected
...
usb usb2: Manufacturer: Linux 4.2.5-300.fc23.x86_64 xhci-hcd
usb usb2: SerialNumber: 0000:00:14.0
hub 2-0:1.0: USB hub found
hub 2-0:1.0: 6 ports detected
...
(Extra PCI card)
usb usb6: Manufacturer: Linux 4.2.5-300.fc23.x86_64 ohci_hcd
usb usb6: SerialNumber: 0000:05:01.0
hub 6-0:1.0: USB hub found
hub 6-0:1.0: 3 ports detected

There are still error when xsane starts
$ dmesg
usb 6-3: usbfs: interface 0 claimed by usblp while 'xsane' sets config #1
usb 6-3: usbfs: process 2434 (xsane) did not claim interface 1 before use

Comment 11 Fedora End Of Life 2015-12-02 02:58:16 UTC
Fedora 21 changed to end-of-life (EOL) status on 2015-12-01. Fedora 21 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.